/// <reference types="node" />
import { OutgoingHttpHeaders } from 'http';
import needle from 'needle';
import * as querystring from 'querystring';
export declare interface Global extends NodeJS.Global {
    ignoreUnknownCA: boolean;
}
export interface Payload {
    body?: needle.BodyData;
    url: string;
    headers?: OutgoingHttpHeaders;
    method: needle.NeedleHttpVerbs;
    qs?: querystring.ParsedUrlQueryInput;
    timeout?: number;
    family?: number;
    attempts?: number;
    retryDelay?: number;
}
export declare function makeRequest(payload: Payload): Promise<{
    success: boolean;
    response: needle.NeedleResponse;
}>;
